<!DOCTYPE html>
<html lang="en">

<head>
    <title>Users CRUD</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

    <div class="container-fluid">
        <div class="text-center">
            <h2>Registration List</h2>
        </div>
        <hr>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-user"> <i class="fa fa-plus"></i>&nbsp; New User </button>
        </div>

        <table class="table table-bordered table-striped table-hover" id="tbl-users">
            <thead style="background-color: rgb(38, 38, 39); text-align: center; color: white">
                <tr>
                    <th scope="col">No.</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register-Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>

    <!-- Vùng Modal -->

    <!-- Create user modal -->
    <div>
        <div id="create-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Create new user</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-firstname">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-firstname" placeholder="Firstname"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-lastname">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-lastname" placeholder="Lastname"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-country">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-create-country" class="form-control">
                                        <option value="VN"> VietNam </option>
                                        <option value="AUS"> Australia </option>
                                        <option value="USA"> USA </option>
                                        <option value="CAN"> Canada </option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-customer-type">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-create-customer-type" class="form-control">
                                        <option value="Standard"> Standard </option>
                                        <option value="Gold"> Gold </option>
                                        <option value="Premium"> Premium </option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <textarea id="textarea-subject" class="form-control"
                                        placeholder="Enter Subject"></textarea>
                                </div>
                            </div>

                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-create-user">Create User</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Update user modal -->
    <div>
        <div id="update-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Update user</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-firstname">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-firstname" placeholder="Firstname"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-lastname">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-lastname" placeholder="Lastname"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-country">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-country" class="form-control">
                                        <option value="VN"> VietNam </option>
                                        <option value="AUS"> Australia </option>
                                        <option value="USA"> USA </option>
                                        <option value="CAN"> Canada </option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-customer-type">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-customer-type" class="form-control">
                                        <option value="Standard"> Standard </option>
                                        <option value="Gold"> Gold </option>
                                        <option value="Premium"> Premium </option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <textarea id="update-textarea-subject" class="form-control"
                                        placeholder="Enter Subject"></textarea>
                                </div>
                            </div>

                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-update-user">Update</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Do you want to delete this user?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>


<script>
    "use strict";


    // gán sự kiện cho các nút Detail


    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    //biến toàn cục để lưu trữ id user đang được update or delete. mặc định là 0
    var gUserId = 0;
    const gDATA_COLUMN = [
        //gán với tên các cột của array
        "id",
        "firstname",
        "lastname",
        "country",
        "subject",
        "customerType",
        "registerStatus",
        "action",
    ];
    const gUSER_ID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTER_STATUS_COL = 6;
    const gACTION_COL = 7;

    //khai báo datatable & mapping columns
    var gUserTable = $("#tbl-users").DataTable({
        //gán column data
        columns: [
            { data: gDATA_COLUMN[gUSER_ID_COL] },
            { data: gDATA_COLUMN[gFIRST_NAME_COL] },
            { data: gDATA_COLUMN[gLAST_NAME_COL] },
            { data: gDATA_COLUMN[gCOUNTRY_COL] },
            { data: gDATA_COLUMN[gSUBJECT_COL] },
            { data: gDATA_COLUMN[gCUSTOMER_TYPE_COL] },
            { data: gDATA_COLUMN[gREGISTER_STATUS_COL] },
            { data: gDATA_COLUMN[gACTION_COL] }
        ],
        columnDefs: [
            //định nghĩa các cột hiện ra
            {
                targets: gACTION_COL,
                className: "text-center",
                defaultContent: `
                        <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                        <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                    `
            }
        ]

    });

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();

        //1 - C: gán sự kiện create
        $("#btn-add-user").on("click", function () {
            onBtnAddUserClick();
        });


        //3- U: gán sự kiện update
        $("#tbl-users").on("click", ".edit-user", function () {
            onBtnEditClick(this);
        });

        //4- D: gán sự kiện delete
        $("#tbl-users").on("click", ".delete-user", function () {
            onBtnDeleteClick(this);
        });

        //gán sự kiện cho nút create user trên modal
        $("#btn-create-user").on("click", function () {
            onBtnCreateUserClick();
        });

        //gán sự kiện cho nút update user trên modal
        $("#btn-update-user").on("click", function () {
            onBtnUpdateUserClick();
        });

        // gán sự kiện cho nút Confirm trên modal delete
        $("#btn-confirm-delete-user").on("click", function () {
            onBtnConfirmDeleteClick();
        });

    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    //hàm onpageload
    function onPageLoading() {
        //1- R: Read / Load user
        callAPIGetDataUser();
    }

    //hàm gọi button sửa
    function onBtnEditClick(paramBtnEdit) {
        "use strict";
        //lưu thông tin userId đang được edit vào biến toàn cục
        gUserId = getUserIdFromButton(paramBtnEdit);
        console.log("Id của user tương ứng = " + gUserId);
        // load dữ liệu vào các trường dữ liệu trong modal
        getUserById(gUserId);
    }

    //hàm xử lý sự kiện khi icon delete user trên bảng được click
    function onBtnDeleteClick(paramBtnDelete) {
        //lưu thông tin userId đang được edit vào biến toàn cục
        gUserId = getUserIdFromButton(paramBtnDelete);
        console.log("Id của user tương ứng = " + gUserId);
        // bật modal confirm lên
        $("#delete-confirm-modal").modal("show");
    }


    // hàm xử lý sự kiện create voucher modal click
    function onBtnAddUserClick() {
        // hiển thị modal trắng lên
        $("#create-user-modal").modal("show");

    };

    //hàm xử lý sự kiện create user modal click
    function onBtnCreateUserClick() {
        console.log("Button create được click");
        //khai báo đối tượng chứa user data
        var vObjRequestData = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: ""
        };
        // B1: Thu thập dữ liệu
        getCreateUserData(vObjRequestData);
        // B2: Validate insert
        var vIsUserValidate = validateUserData(vObjRequestData);
        if (vIsUserValidate) {
            // B3: insert user
            $.ajax({
                url: gBASE_URL,
                type: "POST",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vObjRequestData),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleInsertUserSuccess()
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    }

    // hàm get user by id
    function getUserById(paramUserId) {
        $.ajax({
            url: gBASE_URL + paramUserId,
            type: "GET",
            success: function (paramRes) {
                debugger;
                showVoucherDataToModal(paramRes);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
        // hiển thị modal lên
        $("#update-user-modal").modal("show");
    }

    // hàm show voucher obj lên modal
    function showVoucherDataToModal(paramUserObj) {
        $("#input-update-firstname").val(paramUserObj.firstname);
        $("#input-update-lastname").val(paramUserObj.lastname);
        $("#select-update-country").val(paramUserObj.country);
        $("#update-textarea-subject").val(paramUserObj.subject);
        $("#select-update-customer-type").val(paramUserObj.customerType)
    }

    // hàm xử lý sự kiện update user modal click
    function onBtnUpdateUserClick() {

        // khai báo đối tượng chứa user data
        var vObjRequestData = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: ""
        };
        // B1: Thu thập dữ liệu
        getUpdateUserData(vObjRequestData);
        // B2: Validate update
        var vIsUserValidate = validateUserData(vObjRequestData);
        if (vIsUserValidate) {
            // B3: update voucher
            $.ajax({
                url: gBASE_URL + gUserId,
                type: "PUT",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vObjRequestData),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleUpdateUserSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    }

    // hàm xử lý sự kiện confirm delete
    function onBtnConfirmDeleteClick() {
        // b1: thu thập dữ liệu (ko có)
        // B2: validate dữ liệu (ko có)
        // b3: gọi api để xóa
        $.ajax({
            url: gBASE_URL + gUserId,
            type: "DELETE",
            success: function (paramRes) {
                handleDeleteVoucherSuccess();
            },
            error: function (paramErr) {
                alert("Can not delete this user");
                $("#delete-confirm-modal").modal("hide");
            }
        });
        // b4: xử lý hiển thị front-end
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    //hàm load user data click dùng Ajax
    function callAPIGetDataUser() {
        "use strict";
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            dataType: "json", // added data type
            success: function (res) {
                loadUserDataToTable(res);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText)
            }
        });
    }


    //hàm load data lên table
    function loadUserDataToTable(paramObjUser) {
        "use strict";
        gUserTable.clear();
        gUserTable.rows.add(paramObjUser);
        gUserTable.draw();
    }


    //hàm dựa vào button edit or delete xác định được id user
    function getUserIdFromButton(paramBtn) {
        var vTableRow = $(paramBtn).parents("tr");
        var vUserRowData = gUserTable.row(vTableRow).data();
        return vUserRowData.id;
    }


    //hàm thu thập dữ liệu để create user
    function getCreateUserData(paramUserObj) {
        paramUserObj.firstname = $("#input-create-firstname").val().trim();
        paramUserObj.lastname = $("#input-create-lastname").val().trim();
        paramUserObj.country = $("#select-create-country").val();
        paramUserObj.subject = $("#textarea-subject").val().trim();
        paramUserObj.customerType = $("#select-create-customer-type").val();


    }



    //hàm thu thập dữ liệu để create user
    function getUpdateUserData(paramUserObj) {
        paramUserObj.firstname = $("#input-update-firstname").val().trim();
        paramUserObj.lastname = $("#input-update-lastname").val().trim();
        paramUserObj.country = $("#select-update-country").val();
        paramUserObj.subject = $("#update-textarea-subject").val().trim();
        paramUserObj.customerType = $("#select-update-customer-type").val();
    }



    //hàm validate
    function validateUserData(paramUserObj) {
        if (paramUserObj.firstname === "") {
            alert("Please input firstname");
            return false;
        }
        if (paramUserObj.lastname === "") {
            alert("Please input lastname");
            return false;
        }
        if (paramUserObj.subject === "") {
            alert("Please input subject");
            return false;
        }

        return true;
    }

    //hàm xử lý khi thêm user thành công
    function handleInsertUserSuccess() {
        alert("Added user successfully!");
        callAPIGetDataUser();
        resertCreateUserForm();
        $("#create-user-modal").modal("hide");
    }

    //hàm xử lý khi update thành công
    function handleUpdateUserSuccess() {
        alert("Updated user successfully!");
        callAPIGetDataUser();
        resertCreateUserForm();
        $("#update-user-modal").modal("hide");
    }

    // hàm xử lý hiển thị front-end khi xóa voucher thành công
    function handleDeleteVoucherSuccess() {
        alert("Deleted successfully!");
        callAPIGetDataUser();
        resertCreateUserForm();
        $("#delete-confirm-modal").modal("hide");
    }

    //hàm xóa trắng form create user
    function resertCreateUserForm() {
        $("#input-create-firstname").val("");
        $("#input-create-lastname").val("");
        $("#select-create-country").val("");
        $("#textarea-subject").val("");
        $("#select-create-customer-type").val("");
    }
</script>
</body>

</html>